#include <GUIConstantsEx.au3>
#include <StaticConstants.au3>
#include <WindowsConstants.au3>
#include <ButtonConstants.au3>
#include <GDIPlus.au3>
#Include <WinAPI.au3>

#region Parametres
;recuperation des parametres si le fichier ini existe
If FileExists(@ScriptFullPath & ".ini") Then
	If Not load1() Then
		MsgBox(16,"2048","Erreur..." & @CRLF & "Ini non valide. Veuillier loader manuellement via Nouveau dans Jeu.")
		Global	$v1 = 60 ;decalage horizontal
		Global	$v2 = 100 ;decalage verticale
		Global	$v3 = 111 ;hauteur case
		Global	$v4 = 111 ;largeur case
		Global	$v5 = 10 ;espace entre caque case
		Global	$v6 = 40
		Global	$v7 = 60 ;decalage horizontal fin
	EndIf
Else
	Global $v1 = 60 ;decalage horizontal
	Global $v2 = 100 ;decalage verticale
	Global $v3 = 111 ;hauteur case
	Global $v4 = 111 ;largeur case
	Global $v5 = 10 ;espace entre caque case
	Global $v6 = 40
	Global $v7 = 60 ;decalage horizontal fin
EndIf

Global $case[4][4]
#endregion
#Region ### START Koda GUI section ### Form=

Global $Form1 = GUICreate("2048", 4*$v4 + $v1 + $v7 + 5 * $v5, 4*$v3 + $v2 + $v6+ 5 * $v5, @DesktopWidth/2 - (2*$v4 + $v2+ 2.5 * $v5), @DesktopHeight/2 - (2*$v4 + $v2/2 + $v7/2+ 2.5 * $v5))
GUISetBkColor(0xffffff)

Global $Menu1 = GUICtrlCreateMenu("&Jeu")
Global $new = GUICtrlCreateMenuItem("&Nouveau"&@TAB&"F2", $Menu1)
Global $aide = GUICtrlCreateMenu("&Aide", $Menu1)
Global $help = GUICtrlCreateMenuItem("Comment &jouer ?", $aide)
Global $about = GUICtrlCreateMenuItem("&A propos...", $aide)
GUICtrlCreateMenuItem("",$Menu1)
Global $save = GUICtrlCreateMenuItem("&Sauvgarder"& @TAB & "Fin",$Menu1)
GUICtrlCreateMenuItem("",$Menu1)
Global $best = GUICtrlCreateMenuItem("&Meilleurs scores",$Menu1)
GUICtrlCreateMenuItem("",$Menu1)
Global $quitter = GUICtrlCreateMenuItem("&Quitter"&@TAB&"Echap", $Menu1)
Global $Menu2 = GUICtrlCreateMenu("&Options")
Global $Affichage = GUICtrlCreateMenuItem("&Affichage", $Menu2)
;~ Global $MenuItem4 = GUICtrlCreateMenuItem("", $Menu2)
;~ GUICtrlCreateMenu("")

Local $fond = GUICtrlCreateLabel("",$v1 - $v5,$v2 - $v5,$v3*4 + 5 * $v5 ,$v4*4 + 5 * $v5)
GUICtrlSetBkColor(-1,0x9b8c86)
For $i = 0 to 3
	For $j = 0 to 3
		$case[$i][$j] = GUICtrlCreateButton("0",$v1 + $i * ($v4 + $v5) , $v2 + $j * ($v3 + $v5) , $v4 , $v3 ,$bs_bitmap);BitOR($SS_CENTER,$SS_SUNKEN,$SS_CENTERIMAGE))

	Next
Next
Global $casescore = GUICtrlCreateLabel("0",$v1,($v2 - 40) / 2 , $v4 *2,40,BitOR($SS_CENTER,$SS_CENTERIMAGE))
GUICtrlSetBkColor(-1,0x9b8c86)
GUICtrlSetColor(-1,0xffffff)
GUICtrlSetFont(-1,22,400,0,"Arial")
GUISetState(@SW_SHOW)
#EndRegion ### END Koda GUI section ###
Global $score = 0
#Region
If Not FileExists(@ScriptDir&"\best2048.scores") Then
	For $i = 1 To 10
IniWrite(@ScriptDir&"\best2048.scores","1",$i,StringToBinary("..."))
IniWrite(@ScriptDir&"\best2048.scores","2",$i,StringToBinary("0"))
Next
EndIf
Global $Labelscorestat[10]
Global $bestsc[3][10]; = [[1,2,3,4,5,6,7,8,9,10],[BinaryToString(IniRead(@ScriptDir&"\best2048.scores","1",1,StringToBinary("..."))),BinaryToString(IniRead(@ScriptDir&"\best2048.scores","1",2,StringToBinary("..."))),BinaryToString(IniRead(@ScriptDir&"\best2048.scores","1",3,StringToBinary("..."))),BinaryToString(IniRead(@ScriptDir&"\best2048.scores","1",4,StringToBinary("..."))),BinaryToString(IniRead(@ScriptDir&"\best2048.scores","1",5,StringToBinary("..."))),BinaryToString(IniRead(@ScriptDir&"\best2048.scores","1",6,StringToBinary("..."))),BinaryToString(IniRead(@ScriptDir&"\best2048.scores","1",7,StringToBinary("..."))),BinaryToString(IniRead(@ScriptDir&"\best2048.scores","1",8,StringToBinary("..."))),BinaryToString(IniRead(@ScriptDir&"\best2048.scores","1",9,StringToBinary("..."))),BinaryToString(IniRead(@ScriptDir&"\best2048.scores","1",10,StringToBinary("...")))],[BinaryToString(IniRead(@ScriptDir&"\best2048.scores","2",1,StringToBinary("0"))),BinaryToString(IniRead(@ScriptDir&"\best2048.scores","2",3,StringToBinary("0"))),BinaryToString(IniRead(@ScriptDir&"\best2048.scores","2",3,StringToBinary("0"))),BinaryToString(IniRead(@ScriptDir&"\best2048.scores","2",4,StringToBinary("0"))),BinaryToString(IniRead(@ScriptDir&"\best2048.scores","2",5,StringToBinary("0"))),BinaryToString(IniRead(@ScriptDir&"\best2048.scores","2",6,StringToBinary("0"))),BinaryToString(IniRead(@ScriptDir&"\best2048.scores","2",7,StringToBinary("0"))),BinaryToString(IniRead(@ScriptDir&"\best2048.scores","2",8,StringToBinary("0"))),BinaryToString(IniRead(@ScriptDir&"\best2048.scores","2",9,StringToBinary("0"))),BinaryToString(IniRead(@ScriptDir&"\best2048.scores","2",10,StringToBinary("0")))]]
For $i = 0 to 9
	$bestsc[1][$i] = BinaryToString(IniRead(@ScriptDir&"\best2048.scores","1","a"&$i + 1,StringToBinary("...")))
	$bestsc[2][$i] = BinaryToString(IniRead(@ScriptDir&"\best2048.scores","2","a"&$i + 1,StringToBinary("0")))
;~ 	MsgBox(0,2048,$bestsc[1][$i])
Next
Global $Labeljoueur[10]
If FileExists(@ScriptFullPath & ".ini") Then
load2()
Else
	nouv()
EndIf
;~ HotKeySet("a","optfenetre")
HotKeySet("{F2}","nouv")

HotKeySet("{left}","gauche")
HotKeySet("{right}","droite")
HotKeySet("{up}","haut")
HotKeySet("{down}","bas")
HotKeySet("{end}","save")
While 1

 $nMsg = GUIGetMsg()
 Switch $nMsg
	Case $GUI_EVENT_CLOSE
		save()
		Exit
	Case $quitter
		save()
		Exit
	Case $new
		nouv()
	Case $save
		save()
	Case $Affichage
		optfenetre()
	Case $help
		MsgBox(0,2048,"Utilisez les touches fleches du clavier pour deplasser les cases et les assembler."&@crlf&"Le but du jeu est de faire la case 2048, mais le jeu contine quand mme ensuite."&@CRLF&@CRLF&"Bonne chance...")
	Case $about
		About()
	Case $best
		best()
EndSwitch
WEnd
#endregion
#region Fonctions

Func score($bonus)
	$score = $score + $bonus
Endfunc

Func Actualiser()
;----------------------------------------------
;       Actualise les couleurs
;----------------------------------------------

For $i = 0 To 3
	For $j = 0 To 3
		Switch GUICtrlRead($case[$i][$j])
			Case 0
				GUICtrlSetImage($case[$i][$j],@ScriptDir & "\0.bmp")
 			Case 2
				GUICtrlSetImage($case[$i][$j],@ScriptDir & "\2.bmp")
			Case 4
				GUICtrlSetImage($case[$i][$j],@ScriptDir & "\4.bmp")
			Case 8
				GUICtrlSetImage($case[$i][$j],@ScriptDir & "\8.bmp")
			Case 16
				GUICtrlSetImage($case[$i][$j],@ScriptDir & "\16.bmp")
			Case 32
				GUICtrlSetImage($case[$i][$j],@ScriptDir & "\32.bmp")
			Case 64
				GUICtrlSetImage($case[$i][$j],@ScriptDir & "\64.bmp")
			Case 128
				GUICtrlSetImage($case[$i][$j],@ScriptDir & "\128.bmp")
			Case 256
				GUICtrlSetImage($case[$i][$j],@ScriptDir & "\256.bmp")
			Case 512
				GUICtrlSetImage($case[$i][$j],@ScriptDir & "\512.bmp")
			Case 1024
				GUICtrlSetImage($case[$i][$j],@ScriptDir & "\1024.bmp")
			Case 2048
				GUICtrlSetImage($case[$i][$j],@ScriptDir & "\2048.bmp")
			Case 4096
				GUICtrlSetImage($case[$i][$j],@ScriptDir & "\4096.bmp")
			Case 8192
				GUICtrlSetImage($case[$i][$j],@ScriptDir & "\8192.bmp")
			Case 16384
				GUICtrlSetImage($case[$i][$j],@ScriptDir & "\16384.bmp")
			Case Else
				MsgBox(48,"actualiser","Erreur")
		EndSwitch
	Next
Next

GUICtrlSetData($casescore,$score)

EndFunc
Func a()
	GUICtrlSetData($case[InputBox("horizontale"," ")][InputBox("verticale"," ")],InputBox("Data"," "))
	Actualiser()
EndFunc
Func nouv()
	raz()
	caseauhazard()
	caseauhazard()
	Actualiser()
EndFunc

Func caseauhazard()
For $tmpnul = 0 To 20
	$i = Random(0,3,1);choix d'une case au hazard
	$j = Random(0,3,1)
	If Random(0,2,1) = 0 Then;choix d'une valeur pour la case
		$2ou4 =  4
	Else
		$2ou4 = 2
	EndIf

	If GUICtrlRead($case[$i][$j]) = 0 Then;si la case est vide
		GUICtrlSetData($case[$i][$j],$2ou4)
		$done = 1
		Return $done;on termine la fonction
	Else
		$done = 0
	EndIf
Next
;si parmis les 20 cases testes aucune n'est vide
For $i = 0 To 3
	For $j = 0 To 3
		If GUICtrlRead($case[$i][$j]) = 0 Then;on essaye toute les case pour voir si il y en a une (minimum)de vide
			GUICtrlSetData($case[$i][$j],$2ou4)
			$done = 1
			Return $done
		Else
			$done = 0
		EndIf
	Next
Next

$tmp = 0
If $done = 0 Then;si toutes les case sont remplies
	For $i = 0 To 2
		For $j = 0 To 3
			If GUICtrlRead($case[$i][$j]) = GUICtrlRead($case[$i + 1][$j]) Then
				$tmp += 1;on ajoute 1  la variable tmp  chaque fois qu'il y a un deplacement possible
			EndIf
		Next
	Next
	For $i = 0 To 2
		For $j = 0 To 3
			If GUICtrlRead($case[$j][$i]) = GUICtrlRead($case[$j][$i + 1]) Then;horizontalement et verticalement
				$tmp += 1
			EndIf
		Next
	Next

	If $tmp = 0 Then
;si aucun deplacement possible
		MsgBox(48,"2048","Perdu...")
Return 0
Else
	return 1;sinon on reprend le jeu
	EndIf
EndIf
EndFunc

Func gauche()
$done = 0
For $i = 0 to 3;Je travail ligne par ligne
	;j'ai test tout les cas de figure possibles (avec les valeurs 0;2;4;8, tout marche)
	If GUICtrlRead($case[1][$i]) = 0 And GUICtrlRead($case[2][$i]) = 0 And GUICtrlRead($case[3][$i]) = 0 Then
		Sleep(10)
	Else

	If GUICtrlRead($case[0][$i]) = GUICtrlRead($case[2][$i]) And GUICtrlRead($case[1][$i]) = 0 And GUICtrlRead($case[0][$i]) <> 0 Then;
		Guictrlsetdata($case[0][$i], 2 * GUICtrlRead($case[0][$i]))
		Guictrlsetdata($case[2][$i],0)
		Score(GUICtrlRead($case[0][$i]))
		$done = 1
	ElseIf GUICtrlRead($case[1][$i]) = GUICtrlRead($case[3][$i]) And GUICtrlRead($case[2][$i]) = 0 And GUICtrlRead($case[0][$i]) <> GUICtrlRead($case[1][$i]) Then
		Guictrlsetdata($case[1][$i], 2 * GUICtrlRead($case[1][$i]))
		Guictrlsetdata($case[3][$i],0)
		Score(GUICtrlRead($case[1][$i]))
		$done = 1
	ElseIf GUICtrlRead($case[0][$i]) = GUICtrlRead($case[3][$i]) And GUICtrlRead($case[1][$i]) = 0 And GUICtrlRead($case[2][$i]) = 0 Then
		Guictrlsetdata($case[0][$i], 2 * GUICtrlRead($case[0][$i]))
		Guictrlsetdata($case[3][$i],0)
		Score(GUICtrlRead($case[0][$i]))
			$done = 1


	Else
		If GUICtrlRead($case[0][$i]) = GUICtrlRead($case[1][$i]) And GUICtrlRead($case[0][$i]) <> 0 Then;
			Guictrlsetdata($case[0][$i], 2 * GUICtrlRead($case[0][$i]))
			Guictrlsetdata($case[1][$i],0)
			Score(GUICtrlRead($case[0][$i]))
			$done = 1
		Endif
		If GUICtrlRead($case[1][$i]) = GUICtrlRead($case[2][$i]) And GUICtrlRead($case[1][$i]) <> 0 Then;
			Guictrlsetdata($case[1][$i], 2 * GUICtrlRead($case[1][$i]))
			Guictrlsetdata($case[2][$i],0)
			Score(GUICtrlRead($case[1][$i]))
			$done = 1
		Endif
		If GUICtrlRead($case[2][$i]) = GUICtrlRead($case[3][$i]) And GUICtrlRead($case[2][$i]) <> 0 Then;
			Guictrlsetdata($case[2][$i], 2 * GUICtrlRead($case[2][$i]))
			Guictrlsetdata($case[3][$i],0)
			Score(GUICtrlRead($case[2][$i]))
			$done = 1
		Endif
	EndIf
		For $j = 0 To 2
			If GUICtrlRead($case[0][$i]) = 0 Then
				If GUICtrlRead($case[1][$i]) <> 0 Then
					Guictrlsetdata($case[0][$i], GUICtrlRead($case[1][$i]))
					Guictrlsetdata($case[1][$i],0)
					$done = 1
				Endif
				If GUICtrlRead($case[2][$i]) <> 0 Then
					Guictrlsetdata($case[1][$i], GUICtrlRead($case[2][$i]))
					Guictrlsetdata($case[2][$i],0)
					$done = 1
				Endif
				If GUICtrlRead($case[3][$i]) <> 0 Then
					Guictrlsetdata($case[2][$i], GUICtrlRead($case[3][$i]))
					Guictrlsetdata($case[3][$i],0)
					$done = 1
				Endif
			Elseif Guictrlread($case[1][$i]) = 0 Then
				If GUICtrlRead($case[2][$i]) <> 0 Then
					Guictrlsetdata($case[1][$i], GUICtrlRead($case[2][$i]))
					Guictrlsetdata($case[2][$i],0)
					$done = 1
				Endif
				If GUICtrlRead($case[3][$i]) <> 0 Then
					Guictrlsetdata($case[2][$i], GUICtrlRead($case[3][$i]))
					Guictrlsetdata($case[3][$i],0)
					$done = 1
				Endif
			Elseif Guictrlread($case[2][$i]) = 0 Then
				If GUICtrlRead($case[3][$i]) <> 0 Then
					Guictrlsetdata($case[2][$i], GUICtrlRead($case[3][$i]))
					Guictrlsetdata($case[3][$i],0)
					$done = 1
				Endif
			Endif
		Next
	EndIf
Next

If $done Then
caseauhazard()
Actualiser()
EndIf
verif()
Endfunc

Func droite()
$done = 0
For $i = 0 to 3
	If GUICtrlRead($case[2][$i]) = 0 And GUICtrlRead($case[1][$i]) = 0 And GUICtrlRead($case[0][$i]) = 0 Then
		Sleep(10)
	Else

	If GUICtrlRead($case[3][$i]) = GUICtrlRead($case[1][$i]) And GUICtrlRead($case[2][$i]) = 0 And GUICtrlRead($case[3][$i]) <> 0 Then;
		Guictrlsetdata($case[3][$i], 2 * GUICtrlRead($case[3][$i]))
		Guictrlsetdata($case[1][$i],0)
		Score(GUICtrlRead($case[3][$i]))
		$done = 1
	ElseIf GUICtrlRead($case[2][$i]) = GUICtrlRead($case[0][$i]) And GUICtrlRead($case[1][$i]) = 0 And GUICtrlRead($case[3][$i]) <> GUICtrlRead($case[2][$i]) Then
		Guictrlsetdata($case[2][$i], 2 * GUICtrlRead($case[2][$i]))
		Guictrlsetdata($case[0][$i],0)
		Score(GUICtrlRead($case[2][$i]))
		$done = 1
	ElseIf GUICtrlRead($case[3][$i]) = GUICtrlRead($case[0][$i]) And GUICtrlRead($case[1][$i]) = 0 And GUICtrlRead($case[2][$i]) = 0 Then
		Guictrlsetdata($case[3][$i], 2 * GUICtrlRead($case[3][$i]))
		Guictrlsetdata($case[0][$i],0)
		Score(GUICtrlRead($case[3][$i]))
		$done = 1


	Else
		If GUICtrlRead($case[3][$i]) = GUICtrlRead($case[2][$i]) And GUICtrlRead($case[3][$i]) <> 0 Then;
			Guictrlsetdata($case[3][$i], 2 * GUICtrlRead($case[3][$i]))
			Guictrlsetdata($case[2][$i],0)
			Score(GUICtrlRead($case[3][$i]))
		$done = 1
		Endif
		If GUICtrlRead($case[2][$i]) = GUICtrlRead($case[1][$i]) And GUICtrlRead($case[2][$i]) <> 0 Then;
			Guictrlsetdata($case[2][$i], 2 * GUICtrlRead($case[2][$i]))
			Guictrlsetdata($case[1][$i],0)
			Score(GUICtrlRead($case[2][$i]))
		$done = 1
		Endif
		If GUICtrlRead($case[1][$i]) = GUICtrlRead($case[0][$i]) And GUICtrlRead($case[1][$i]) <> 0 Then;
			Guictrlsetdata($case[1][$i], 2 * GUICtrlRead($case[1][$i]))
			Guictrlsetdata($case[0][$i],0)
			Score(GUICtrlRead($case[1][$i]))
		$done = 1
		Endif
	EndIf


		For $j = 0 To 2
			If GUICtrlRead($case[3][$i]) = 0 Then
				If GUICtrlRead($case[2][$i]) <> 0 Then
					Guictrlsetdata($case[3][$i], GUICtrlRead($case[2][$i]))
					Guictrlsetdata($case[2][$i],0)
		$done = 1
				Endif
				If GUICtrlRead($case[1][$i]) <> 0 Then
					Guictrlsetdata($case[2][$i], GUICtrlRead($case[1][$i]))
					Guictrlsetdata($case[1][$i],0)
		$done = 1
				Endif
				If GUICtrlRead($case[0][$i]) <> 0 Then
					Guictrlsetdata($case[1][$i], GUICtrlRead($case[0][$i]))
					Guictrlsetdata($case[0][$i],0)
		$done = 1
				Endif
			Elseif Guictrlread($case[2][$i]) = 0 Then
				If GUICtrlRead($case[1][$i]) <> 0 Then
					Guictrlsetdata($case[2][$i], GUICtrlRead($case[1][$i]))
					Guictrlsetdata($case[1][$i],0)
		$done = 1
				Endif
				If GUICtrlRead($case[0][$i]) <> 0 Then
					Guictrlsetdata($case[1][$i], GUICtrlRead($case[0][$i]))
					Guictrlsetdata($case[0][$i],0)
		$done = 1
				Endif
			Elseif Guictrlread($case[1][$i]) = 0 Then
				If GUICtrlRead($case[0][$i]) <> 0 Then
					Guictrlsetdata($case[1][$i], GUICtrlRead($case[0][$i]))
					Guictrlsetdata($case[0][$i],0)
		$done = 1
				Endif
			Endif
		Next
	EndIf
Next
If $done Then
caseauhazard()
Actualiser()
EndIf
verif()
Endfunc

Func haut()
$done = 0
For $i = 0 to 3
	If GUICtrlRead($case[$i][1]) = 0 And GUICtrlRead($case[$i][2]) = 0 And GUICtrlRead($case[$i][3]) = 0 Then
		Sleep(10)
	Else

	If GUICtrlRead($case[$i][0]) = GUICtrlRead($case[$i][2]) And GUICtrlRead($case[$i][1]) = 0 And GUICtrlRead($case[$i][0]) <> 0 Then;
		Guictrlsetdata($case[$i][0], 2 * GUICtrlRead($case[$i][0]))
		Guictrlsetdata($case[$i][2],0)
		Score(GUICtrlRead($case[$i][0]))
			$done = 1
	ElseIf GUICtrlRead($case[$i][1]) = GUICtrlRead($case[$i][3]) And GUICtrlRead($case[$i][2]) = 0 And GUICtrlRead($case[$i][0]) <> GUICtrlRead($case[$i][1])Then
		Guictrlsetdata($case[$i][1], 2 * GUICtrlRead($case[$i][1]))
		Guictrlsetdata($case[$i][3],0)
		Score(GUICtrlRead($case[$i][1]))
			$done = 1
	ElseIf GUICtrlRead($case[$i][0]) = GUICtrlRead($case[$i][3]) And GUICtrlRead($case[$i][1]) = 0 And GUICtrlRead($case[$i][2]) = 0 Then
		Guictrlsetdata($case[$i][0], 2 * GUICtrlRead($case[$i][0]))
		Guictrlsetdata($case[$i][3],0)
		Score(GUICtrlRead($case[$i][0]))
			$done = 1


	Else
		If GUICtrlRead($case[$i][0]) = GUICtrlRead($case[$i][1]) And GUICtrlRead($case[$i][0]) <> 0 Then;
			Guictrlsetdata($case[$i][0], 2 * GUICtrlRead($case[$i][0]))
			Guictrlsetdata($case[$i][1],0)
			Score(GUICtrlRead($case[$i][0]))
			$done = 1
		Endif
		If GUICtrlRead($case[$i][1]) = GUICtrlRead($case[$i][2]) And GUICtrlRead($case[$i][1]) <> 0 Then;
			Guictrlsetdata($case[$i][1], 2 * GUICtrlRead($case[$i][1]))
			Guictrlsetdata($case[$i][2],0)
			Score(GUICtrlRead($case[$i][1]))
			$done = 1
		Endif
		If GUICtrlRead($case[$i][2]) = GUICtrlRead($case[$i][3]) And GUICtrlRead($case[$i][2]) <> 0 Then;
			Guictrlsetdata($case[$i][2], 2 * GUICtrlRead($case[$i][2]))
			Guictrlsetdata($case[$i][3],0)
			Score(GUICtrlRead($case[$i][2]))
			$done = 1
		Endif
	EndIf


		For $j = 0 To 2
			If GUICtrlRead($case[$i][0]) = 0 Then
				If GUICtrlRead($case[$i][1]) <> 0 Then
					Guictrlsetdata($case[$i][0], GUICtrlRead($case[$i][1]))
					Guictrlsetdata($case[$i][1],0)
			$done = 1
				Endif
				If GUICtrlRead($case[$i][2]) <> 0 Then
					Guictrlsetdata($case[$i][1], GUICtrlRead($case[$i][2]))
					Guictrlsetdata($case[$i][2],0)
			$done = 1
				Endif
				If GUICtrlRead($case[$i][3]) <> 0 Then
					Guictrlsetdata($case[$i][2], GUICtrlRead($case[$i][3]))
					Guictrlsetdata($case[$i][3],0)
			$done = 1
				Endif
			Elseif Guictrlread($case[$i][1]) = 0 Then
				If GUICtrlRead($case[$i][2]) <> 0 Then
					Guictrlsetdata($case[$i][1], GUICtrlRead($case[$i][2]))
					Guictrlsetdata($case[$i][2],0)
			$done = 1
				Endif
				If GUICtrlRead($case[$i][3]) <> 0 Then
					Guictrlsetdata($case[$i][2], GUICtrlRead($case[$i][3]))
					Guictrlsetdata($case[$i][3],0)
			$done = 1
				Endif
			Elseif Guictrlread($case[$i][2]) = 0 Then
				If GUICtrlRead($case[$i][3]) <> 0 Then
					Guictrlsetdata($case[$i][2], GUICtrlRead($case[$i][3]))
					Guictrlsetdata($case[$i][3],0)
			$done = 1
				Endif
			Endif
		Next
	EndIf
Next
If $done Then
caseauhazard()
Actualiser()
EndIf
verif()
Endfunc

Func bas()
$done = 0
For $i = 0 to 3
	If GUICtrlRead($case[$i][2]) = 0 And GUICtrlRead($case[$i][1]) = 0 And GUICtrlRead($case[$i][0]) = 0 Then
		Sleep(10)
	Else

	If GUICtrlRead($case[$i][3]) = GUICtrlRead($case[$i][1]) And GUICtrlRead($case[$i][2]) = 0 And GUICtrlRead($case[$i][3]) <> 0 Then
		Guictrlsetdata($case[$i][3], 2 * GUICtrlRead($case[$i][3]))
		Guictrlsetdata($case[$i][1],0)
		Score(GUICtrlRead($case[$i][3]))
		$done = 1
	ElseIf GUICtrlRead($case[$i][2]) = GUICtrlRead($case[$i][0]) And GUICtrlRead($case[$i][1]) = 0 And GUICtrlRead($case[$i][3]) <> GUICtrlRead($case[$i][2])Then
		Guictrlsetdata($case[$i][2], 2 * GUICtrlRead($case[$i][2]))
		Guictrlsetdata($case[$i][0],0)
		Score(GUICtrlRead($case[$i][2]))
		$done = 1
	ElseIf GUICtrlRead($case[$i][3]) = GUICtrlRead($case[$i][0]) And GUICtrlRead($case[$i][2]) = 0 And GUICtrlRead($case[$i][1]) = 0 Then
		Guictrlsetdata($case[$i][3], 2 * GUICtrlRead($case[$i][3]))
		Guictrlsetdata($case[$i][0],0)
		Score(GUICtrlRead($case[$i][3]))
			$done = 1
	Else
		If GUICtrlRead($case[$i][3]) = GUICtrlRead($case[$i][2]) And GUICtrlRead($case[$i][3]) <> 0 Then;
			Guictrlsetdata($case[$i][3], 2 * GUICtrlRead($case[$i][3]))
			Guictrlsetdata($case[$i][2],0)
			Score(GUICtrlRead($case[$i][3]))
			$done = 1
		Endif
		If GUICtrlRead($case[$i][2]) = GUICtrlRead($case[$i][1]) And GUICtrlRead($case[$i][2]) <> 0 Then;
			Guictrlsetdata($case[$i][2], 2 * GUICtrlRead($case[$i][2]))
			Guictrlsetdata($case[$i][1],0)
			Score(GUICtrlRead($case[$i][2]))
			$done = 1
		Endif
		If GUICtrlRead($case[$i][1]) = GUICtrlRead($case[$i][0]) And GUICtrlRead($case[$i][1]) <> 0 Then;
			Guictrlsetdata($case[$i][1], 2 * GUICtrlRead($case[$i][1]))
			Guictrlsetdata($case[$i][0],0)
			Score(GUICtrlRead($case[$i][1]))
			$done = 1
		Endif
	EndIf
		For $j = 0 To 2
			If GUICtrlRead($case[$i][3]) = 0 Then
				If GUICtrlRead($case[$i][2]) <> 0 Then
					Guictrlsetdata($case[$i][3], GUICtrlRead($case[$i][2]))
					Guictrlsetdata($case[$i][2],0)
					$done = 1
				Endif
				If GUICtrlRead($case[$i][1]) <> 0 Then
					Guictrlsetdata($case[$i][2], GUICtrlRead($case[$i][1]))
					Guictrlsetdata($case[$i][1],0)
					$done = 1
				Endif
				If GUICtrlRead($case[$i][0]) <> 0 Then
					Guictrlsetdata($case[$i][1], GUICtrlRead($case[$i][0]))
					Guictrlsetdata($case[$i][0],0)
					$done = 1
				Endif
			Elseif Guictrlread($case[$i][2]) = 0 Then
				If GUICtrlRead($case[$i][1]) <> 0 Then
					Guictrlsetdata($case[$i][2], GUICtrlRead($case[$i][1]))
					Guictrlsetdata($case[$i][1],0)
					$done = 1
				Endif
				If GUICtrlRead($case[$i][0]) <> 0 Then
					Guictrlsetdata($case[$i][1], GUICtrlRead($case[$i][0]))
					Guictrlsetdata($case[$i][0],0)
					$done = 1
				Endif
			Elseif Guictrlread($case[$i][1]) = 0 Then
				If GUICtrlRead($case[$i][0]) <> 0 Then
					Guictrlsetdata($case[$i][1], GUICtrlRead($case[$i][0]))
					Guictrlsetdata($case[$i][0],0)
					$done = 1
				Endif
			Endif
		Next
	EndIf
Next

If $done Then
caseauhazard()
Actualiser()
EndIf
verif()
Endfunc

Func raz()
	$score = 0
	For $i = 0 to 3
		For $j = 0 To 3
			GUICtrlSetData($case[$i][$j],"0")
		Next
	Next
	Actualiser()
EndFunc

Func save()
	FileDelete(@ScriptFullPath & ".ini")
	;il y a une seule fonction save qui s'enclanche quand la fenetre se ferme
	IniWriteSection(@ScriptFullPath & ".ini", "cases","")
	For $i = 0 To 3
		For $j = 0 To 3
			IniWrite(@ScriptFullPath & ".ini", "cases", $i & $j, GUICtrlRead($case[$i][$j]))
		Next
	Next
	IniWriteSection(@ScriptFullPath & ".ini", "fenetre", "")
IniWrite(@ScriptFullPath & ".ini","fenetre" , "41",$v1)
IniWrite(@ScriptFullPath & ".ini","fenetre", "42",$v2)
IniWrite(@ScriptFullPath & ".ini","fenetre", "43",$v3)
IniWrite(@ScriptFullPath & ".ini","fenetre", "44",$v4)
IniWrite(@ScriptFullPath & ".ini","fenetre", "45",$v5)
IniWrite(@ScriptFullPath & ".ini","fenetre", "46",$v6)
IniWrite(@ScriptFullPath & ".ini","fenetre", "47",$v7)

IniWrite(@ScriptFullPath & ".ini","fenetre", "score",$score)

For $i = 0 To 9
	IniWrite(@ScriptDir&"\best2048.scores","1","a"&($i+1),StringToBinary($bestsc[1][$i]))
	IniWrite(@ScriptDir&"\best2048.scores","2","a"&($i+1),StringToBinary($bestsc[2][$i]))
Next
EndFunc

Func load1()
	;il y a deux fonctions load :
	;une pour les parametres de taille de la fenetre (celle-ci)
	;l'autre pour les valeurs des cases du jeu
;~ 						file name		section		key
Global	$v1 = IniRead(@ScriptFullPath & ".ini","fenetre",41,60)
Global	$v2 = IniRead(@ScriptFullPath & ".ini","fenetre",42,100)
Global	$v3 = IniRead(@ScriptFullPath & ".ini","fenetre",43,119)
Global	$v4 = IniRead(@ScriptFullPath & ".ini","fenetre",44,119)
Global	$v5 = IniRead(@ScriptFullPath & ".ini","fenetre",45,10)
Global	$v6 = IniRead(@ScriptFullPath & ".ini","fenetre",46,40)
Global	$v7 = IniRead(@ScriptFullPath & ".ini","fenetre",47,60)
	If Not @error Then Return 1
EndFunc

Func load2()
	For $i = 0 To 3
		For $j = 0 To 3
			GUICtrlSetData($case[$i][$j], IniRead(@ScriptFullPath & ".ini", "cases", $i & $j, 0))
		Next
	Next
	$score = IniRead(@ScriptFullPath & ".ini","fenetre","score",0)
	Actualiser()
EndFunc

Func optfenetre()
#Region ### START Koda GUI section ### Form=
Global $Form2 = GUICreate("Options", 400, 250, 192, 124)
Global $Label1 = GUICtrlCreateLabel("Espace gauche :", 25, 15, 85, 17)
Global $Label2 = GUICtrlCreateLabel("Espace droite :", 25, 40, 85, 17)
Global $Label3 = GUICtrlCreateLabel("Espace haut :", 25, 65, 85, 17)
Global $Label4 = GUICtrlCreateLabel("Espace bas :", 25, 90, 85, 17)
Global $upd1 = GUICtrlCreateInput($v1,115,15,45,17)
Global $ud1 = GUICtrlCreateUpdown(-1)
Global $upd7 = GUICtrlCreateInput($v7,115,40,45,17)
Global $ud2 = GUICtrlCreateUpdown(-1)
Global $upd2 = GUICtrlCreateInput($v2,115,65,45,17)
Global $ud3 = GUICtrlCreateUpdown(-1)
Global $upd6 = GUICtrlCreateInput($v6,115,90,45,17)
Global $ud4 = GUICtrlCreateUpdown(-1)

Global $Label5 = GUICtrlCreateLabel("Largeur des cases :", 25, 135, 125, 17)
Global $Label6 = GUICtrlCreateLabel("Hauteur des cases :", 25, 160, 125, 17)
Global $Label8 = GUICtrlCreateLabel("Espace entre deux cases :", 15, 185, 130, 17)

Global $upd4 = GUICtrlCreateInput($v4,155,135,45,17)
Global $ud5 = GUICtrlCreateUpdown(-1)
Global $upd3 = GUICtrlCreateInput($v3,155,160,45,17)
Global $ud6 = GUICtrlCreateUpdown(-1)
Global $upd5 = GUICtrlCreateInput($v5,155,185,45,17)
Global $ud7 = GUICtrlCreateUpdown(-1)

Global $bpok = GUICtrlCreateButton("&OK",25,215,100,25)
Global $bpan = GUICtrlCreateButton("&Annuler",150,215,100,25)
GUISetState(@SW_SHOW)
#EndRegion ### END Koda GUI section ###

While 1
 $nMsg = GUIGetMsg()
 Switch $nMsg
	Case $GUI_EVENT_CLOSE
		$nMsg = 0
		GUISetState(@SW_HIDE,$Form2)
		GUICtrlDelete($Label1)
		GUICtrlDelete($Label2)
		GUICtrlDelete($Label3)
		GUICtrlDelete($Label4)
		GUICtrlDelete($upd1)
		GUICtrlDelete($upd2)
		GUICtrlDelete($upd6)
		GUICtrlDelete($upd7)
		Return 1
	Case $bpan
		$nMsg = 0
		GUISetState(@SW_HIDE,$Form2)
		GUICtrlDelete($Label1)
		GUICtrlDelete($Label2)
		GUICtrlDelete($Label3)
		GUICtrlDelete($Label4)
		GUICtrlDelete($upd1)
		GUICtrlDelete($upd2)
		GUICtrlDelete($upd6)
		GUICtrlDelete($upd7)
		Return 1
	Case $bpok
		$v1 = GUICtrlRead($upd1)
		$v2 = GUICtrlRead($upd2)
		$v3 = GUICtrlRead($upd3)
		$v4 = GUICtrlRead($upd4)
		$v5 = GUICtrlRead($upd5)
		$v6 = GUICtrlRead($upd6)
		$v7 = GUICtrlRead($upd7)
		save()
		MsgBox(64,"2048 Info...","Attention,"&@CRLF&@CRLF&"Ces modifications seront prisent en compte lors du prochain demarrage de l'application.")
		$nMsg = 0
		GUISetState(@SW_HIDE,$Form2)
		GUICtrlDelete($Label1)
		GUICtrlDelete($Label2)
		GUICtrlDelete($Label3)
		GUICtrlDelete($Label4)
		GUICtrlDelete($upd1)
		GUICtrlDelete($upd2)
		GUICtrlDelete($upd6)
		GUICtrlDelete($upd7)
		Return 1
 EndSwitch
WEnd
EndFunc

Func About()
	#Region ### START Koda GUI section ### Form=
Global $Form3 = GUICreate("A Propos...", 324, 275, 302, 218)
Global $GroupBox1 = GUICtrlCreateGroup("", 8, 8, 305, 255)
GUICtrlSetFont(-1, 10, 400, 0, "MS Sans Serif")
GUICtrlSetColor(-1, 0x000000)
Global $Image1 = GUICtrlCreatePic(@ScriptDir&"\2048.bmp", 16, 24, 105, 97)
Global $Label1 = GUICtrlCreateLabel("Nom : 2048", 144, 24, 96, 20)
Global $Label2 = GUICtrlCreateLabel("Version : 3.0.8", 144, 72, 100, 20)
Global $Label4 = GUICtrlCreateLabel("Commentaires :"&@CRLF & @TAB & "Jeu 2048 programm grace au logiciel Autoit. On peut desormais y jouer sur ordinnateur Hors ligne, pratique quand les connexions sont limites ou innexistantes..", 16, 128, 275, 85)
Global $Label3 = GUICtrlCreateLabel("Auteur : ...", 145, 48, 100, 20)
GUICtrlCreateGroup("", -99, -99, 1, 1)
Global $bpvalid = GUICtrlCreateButton("&Valider", 112, 220, 75, 25, 0)
GUICtrlSetCursor (-1, 0)
GUISetState(@SW_SHOW)
#EndRegion ### END Koda GUI section ###

While 1
 $nMsg = GUIGetMsg()
 Switch $nMsg
  Case $GUI_EVENT_CLOSE
		$nMsg = 0
		GUISetState(@SW_HIDE,$Form3)

		Return 1
	Case $bpvalid
		$nMsg = 0
		GUISetState(@SW_HIDE,$Form3)

		Return 1

 EndSwitch
WEnd
EndFunc
Func verif()

$tmp = 0
	For $i = 0 To 2
		For $j = 0 To 3
			If GUICtrlRead($case[$i][$j]) = GUICtrlRead($case[$i + 1][$j]) Then
				$tmp += 1;on ajoute 1  la variable tmp  chaque fois qu'il y a un deplacement possible
			EndIf
		Next
	Next
	For $i = 0 To 2
		For $j = 0 To 3
			If GUICtrlRead($case[$j][$i]) = GUICtrlRead($case[$j][$i + 1]) Then;horizontalement et verticalement
				$tmp += 1
			EndIf
		Next
	Next
$tmp2 = 1
For $i = 0 To 3
	For $j = 0 To 3
		$tmp2 = $tmp2 * GUICtrlRead($case[$i][$j])
	Next
Next
	If $tmp = 0 And $tmp2 <> 0 Then
;si aucun deplacement possible
		MsgBox(48,"2048","Perdu...")
		If $score > $bestsc[2][9] Then class()
$tmp = MsgBox(36,"2048","Rejouer ?")
If $tmp = 6 Then
nouv()
Else
	Exit
EndIf
EndIf
EndFunc

Func best()
For $i = 0 to 9
	$bestsc[1][$i] = BinaryToString(IniRead(@ScriptDir&"\best2048.scores","1","a"&$i + 1,StringToBinary("...")))
	$bestsc[2][$i] = BinaryToString(IniRead(@ScriptDir&"\best2048.scores","2","a"&$i + 1,StringToBinary("0")))
	MsgBox(0,2048,$bestsc[1][$i])
Next
#Region ### START Koda GUI section ### Form=
Global $Form4 = GUICreate("2048", 419, 527, 192, 124)
GUISetBkColor(0xFFFFFF)
Global $Bpbok = GUICtrlCreateButton("&OK", 16, 480, 169, 33)
;~ Global $Button2 = GUICtrlCreateButton("Effacer les scores", 216, 480, 169, 33)
Global $Button2 = GUICtrlCreateButton("Effacer les scores", 216, 480, 169, 33)
If @UserName <> "UserName" Then GUIctrlSetState(-1,$GUI_disable)

Global $Label1 = GUICtrlCreateLabel("Meilleurs scores", 8, 8, 396, 68)
GUICtrlSetFont(-1, 40, 400, 0, "MS Sans Serif")
For $k = 1 To 10
	GUICtrlCreateLabel($k, 15, 80 + 25 * $k, 17, 21,BitOR($SS_CENTER,$SS_CENTERIMAGE))
	GUICtrlSetBkColor(-1, 0xC0C0C0)
Next
For $k = 0 To 9
	$Labeljoueur[$k] = GUICtrlCreateLabel($bestsc[1][$k], 40, 105 + 25 * $k, 165, 21,$SS_CENTERIMAGE)
	GUICtrlSetBkColor(-1, 0xC0C0C0)
	$Labelscorestat[$k] = GUICtrlCreateLabel($bestsc[2][$k],220,105 + 25 * $k,125,21,BitOR($SS_CENTER,$SS_CENTERIMAGE))
	GUICtrlSetBkColor(-1, 0xC0C0C0)
Next
save()
GUISetState(@SW_SHOW)
#EndRegion ### END Koda GUI section ###

While 1
 $nMsg = GUIGetMsg()
 Switch $nMsg
  Case $GUI_EVENT_CLOSE
   $nMsg = 0
   GUISetState(@SW_HIDE,$Form4)
   Return 1
	Case $Bpbok
		$nMsg = 0
		GUISetState(@SW_HIDE,$Form4)
		Return 1
	Case $Button2
		clearscores()
 EndSwitch
WEnd

EndFunc
#endregion
Func class()
	For $i = 0 To 9
		If $score > $bestsc[2][$i] Then
			For $j = 9 to $i Step -1
				If $j <> 0 Then
					$bestsc[2][$j] = $bestsc[2][$j - 1]
					$bestsc[1][$j] = $bestsc[1][$j - 1]
				EndIf
			Next
			$bestsc[2][$i] = $score
			$bestsc[1][$i] = InputBox("2048","Meilleurs score."&@CRLF&@CRLF&"Entrez votre nom.","Player...")
			Return 1
		EndIf
	Next
EndFunc

Func clearscores()
	For $i = 1 To 10
IniWrite(@ScriptDir&"\best2048.scores","1",$i,StringToBinary("..."))
IniWrite(@ScriptDir&"\best2048.scores","2",$i,StringToBinary("0"))
Next

Global $bestsc[3][10] = [[1,2,3,4,5,6,7,8,9,10],[BinaryToString(IniRead(@ScriptDir&"\best2048.scores","1",1,StringToBinary("..."))),BinaryToString(IniRead(@ScriptDir&"\best2048.scores","1",2,StringToBinary("..."))),BinaryToString(IniRead(@ScriptDir&"\best2048.scores","1",3,StringToBinary("..."))),BinaryToString(IniRead(@ScriptDir&"\best2048.scores","1",4,StringToBinary("..."))),BinaryToString(IniRead(@ScriptDir&"\best2048.scores","1",5,StringToBinary("..."))),BinaryToString(IniRead(@ScriptDir&"\best2048.scores","1",6,StringToBinary("..."))),BinaryToString(IniRead(@ScriptDir&"\best2048.scores","1",7,StringToBinary("..."))),BinaryToString(IniRead(@ScriptDir&"\best2048.scores","1",8,StringToBinary("..."))),BinaryToString(IniRead(@ScriptDir&"\best2048.scores","1",9,StringToBinary("..."))),BinaryToString(IniRead(@ScriptDir&"\best2048.scores","1",10,StringToBinary("...")))],[BinaryToString(IniRead(@ScriptDir&"\best2048.scores","2",1,StringToBinary("0"))),BinaryToString(IniRead(@ScriptDir&"\best2048.scores","2",3,StringToBinary("0"))),BinaryToString(IniRead(@ScriptDir&"\best2048.scores","2",3,StringToBinary("0"))),BinaryToString(IniRead(@ScriptDir&"\best2048.scores","2",4,StringToBinary("0"))),BinaryToString(IniRead(@ScriptDir&"\best2048.scores","2",5,StringToBinary("0"))),BinaryToString(IniRead(@ScriptDir&"\best2048.scores","2",6,StringToBinary("0"))),BinaryToString(IniRead(@ScriptDir&"\best2048.scores","2",7,StringToBinary("0"))),BinaryToString(IniRead(@ScriptDir&"\best2048.scores","2",8,StringToBinary("0"))),BinaryToString(IniRead(@ScriptDir&"\best2048.scores","2",9,StringToBinary("0"))),BinaryToString(IniRead(@ScriptDir&"\best2048.scores","2",10,StringToBinary("0")))]]
save()
EndFunc